<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOTA_InsurancePlanSearchRQCoveragePreference
 * ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfOTA_InsurancePlanSearchRQCoveragePreference extends AbstractStructArrayBase
{
    /**
     * The CoveragePreference
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference[]
     */
    public $CoveragePreference;
    /**
     * Constructor method for ArrayOfOTA_InsurancePlanSearchRQCoveragePreference
     * @uses DgArrayOfOTA_InsurancePlanSearchRQCoveragePreference::setCoveragePreference()
     * @param \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference[] $coveragePreference
     */
    public function __construct(array $coveragePreference = array())
    {
        $this
            ->setCoveragePreference($coveragePreference);
    }
    /**
     * Get CoveragePreference value
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference[]|null
     */
    public function getCoveragePreference()
    {
        return $this->CoveragePreference;
    }
    /**
     * Set CoveragePreference value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference[] $coveragePreference
     * @return \dgsoft\ArrayType\DgArrayOfOTA_InsurancePlanSearchRQCoveragePreference
     */
    public function setCoveragePreference(array $coveragePreference = array())
    {
        foreach ($coveragePreference as $arrayOfOTA_InsurancePlanSearchRQCoveragePreferenceCoveragePreferenceItem) {
            // validation for constraint: itemType
            if (!$arrayOfOTA_InsurancePlanSearchRQCoveragePreferenceCoveragePreferenceItem instanceof \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference) {
                throw new \InvalidArgumentException(sprintf('The CoveragePreference property can only contain items of \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference, "%s" given', is_object($arrayOfOTA_InsurancePlanSearchRQCoveragePreferenceCoveragePreferenceItem) ? get_class($arrayOfOTA_InsurancePlanSearchRQCoveragePreferenceCoveragePreferenceItem) : gettype($arrayOfOTA_InsurancePlanSearchRQCoveragePreferenceCoveragePreferenceItem)), __LINE__);
            }
        }
        $this->CoveragePreference = $coveragePreference;
        return $this;
    }
    /**
     * Add item to CoveragePreference value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference $item
     * @return \dgsoft\ArrayType\DgArrayOfOTA_InsurancePlanSearchRQCoveragePreference
     */
    public function addToCoveragePreference(\dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference) {
            throw new \InvalidArgumentException(sprintf('The CoveragePreference property can only contain items of \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CoveragePreference[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQCoveragePreference|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CoveragePreference
     */
    public function getAttributeName()
    {
        return 'CoveragePreference';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfOTA_InsurancePlanSearchRQCoveragePreference
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
